Redmine - Defect #24910

Issue processing UTF7 mails
2017-01-23 22:12 - Falk Eckert

Status: New Start date:

Priority: Low Due date:

Assignee: % Done: 0%
Category: Email receiving Estimated time: 0.00 hour

Target version:

Resolution: Affected version:

Description
Hello,

we have an issue with processing UTF7 mails:

exception: code converter not found (UTF-7 to UTF-8)

["/srv/redmine/public_html/lib/redmine/codeset_util.rb:25:in “encode™, "/srv/redmine/public_html/lib/redmine/codeset_util.rb:25:in
“to_utf8™

Are there any ideas to solve this issue?

Thx
Falk

History

#1 - 2017-01-24 02:47 - Go MAEDA

- Category set to Email receiving

#2 - 2017-01-24 04:37 - Toshi MARUYAMA

$ cat /etc/redhat-release
CentOS Linux release 7.3.1611 (Core)

$ irb

1.9.3-p551 :001 > str = "test".force_encoding ("UTF-7")

=> "\x74\x65\x73\x74"

1.9.3-p551 :002 > str = str.encode ("UTF-8", :invalid => :replace, :undef => :replace, :replace => '?')

Encoding: :ConverterNotFoundError: code converter not found (UTF-7 to UTF-8)
from (irb):2:in “encode'
from (irb) :2
from /home/xxxx/.rvm/rubies/ruby-1.9.3-p551/bin/irb:12:in " <main>'

#3 - 2017-01-24 04:51 - Toshi MARUYAMA

- Priority changed from Normal to Low

It seems Ruby does not have UTF-7 converter.

"Code converter not found (UTF-8 to EUC-TW)": https://bugs.ruby-lang.org/issues/6995

#4 - 2017-04-06 05:30 - Fred Sanger
This encyclopedia article for UTF7 seems to be a good place to start

#5 - 2017-04-07 22:48 - Pavel Rosicky

toshio harita: utf-7 is relevant only for email processing. Ruby still supports it, but it's a little bit tricky. This will work:

require "net/imap"
Net: :IMAP.decode_utf7 (mail_body)

#6 - 2020-09-14 13:28 - Karel Picman

- File converter_not_found.patch added
https://bugs.ruby-lang.org/issues/6995
https://www.everipedia.com/UTF7/
https://www.redmine.org/users/10651

The same problem with Windows-1258. Attached patch should cover all not supported code pages.

#7 - 2020-09-14 13:55 - Pavel Rosicky

WBaH Kapenbckuii
could you add a more realistic test case with an email as a fixture?

https://github.com/redmine/redmine/blob/3ac569c4d8c8b04a9cc33e3c2a058553d99827 e/test/unit/mail_handler_test.rb#L.542

it should be already fixed by
https://github.com/mikel/mail/pull/1112

#8 - 2020-09-17 14:38 - Karel Picman

- File converter_not_found2.patch added

A test with a real Vietnamese email added into the patch.

Files

converter_not_found.patch 1.45 KB 2020-09-14 Karel Piéman

converter_not_found2.patch 2.78 KB 2020-09-17 Karel Piéman
https://www.redmine.org/users/699023
https://github.com/redmine/redmine/blob/3ac569c4d8c8b04a9cc33e3c2a05f8553d99827e/test/unit/mail_handler_test.rb#L542
https://github.com/mikel/mail/pull/1112
http://www.tcpdf.org

